## MmGdbusModemVoice MmGdbusModemVoice — Generated C code for the org.freedesktop.ModemManager1.Modem.Voice D-Bus interface |

## Functions

const gchar *const * | mm_gdbus_modem_voice_get_calls ()
gchar ** | mm_gdbus_modem_voice_dup_calls ()
gboolean | mm_gdbus_modem_voice_get_emergency_only ()
void | mm_gdbus_modem_voice_call_create_call ()
gboolean | mm_gdbus_modem_voice_call_create_call_finish ()
gboolean | mm_gdbus_modem_voice_call_create_call_sync ()
void | mm_gdbus_modem_voice_call_delete_call ()
gboolean | mm_gdbus_modem_voice_call_delete_call_finish ()
gboolean | mm_gdbus_modem_voice_call_delete_call_sync ()
void | mm_gdbus_modem_voice_call_list_calls ()
gboolean | mm_gdbus_modem_voice_call_list_calls_finish ()
gboolean | mm_gdbus_modem_voice_call_list_calls_sync ()
void | mm_gdbus_modem_voice_call_hangup_and_accept ()
gboolean | mm_gdbus_modem_voice_call_hangup_and_accept_finish ()
gboolean | mm_gdbus_modem_voice_call_hangup_and_accept_sync ()
void | mm_gdbus_modem_voice_call_hold_and_accept ()
gboolean | mm_gdbus_modem_voice_call_hold_and_accept_finish ()
gboolean | mm_gdbus_modem_voice_call_hold_and_accept_sync ()
void | mm_gdbus_modem_voice_call_hangup_all ()
gboolean | mm_gdbus_modem_voice_call_hangup_all_finish ()
gboolean | mm_gdbus_modem_voice_call_hangup_all_sync ()
void | mm_gdbus_modem_voice_call_transfer ()
gboolean | mm_gdbus_modem_voice_call_transfer_finish ()
gboolean | mm_gdbus_modem_voice_call_transfer_sync ()
void | mm_gdbus_modem_voice_call_call_waiting_query ()
gboolean | mm_gdbus_modem_voice_call_call_waiting_query_finish ()
gboolean | mm_gdbus_modem_voice_call_call_waiting_query_sync ()
void | mm_gdbus_modem_voice_call_call_waiting_setup ()
gboolean | mm_gdbus_modem_voice_call_call_waiting_setup_finish ()
gboolean | mm_gdbus_modem_voice_call_call_waiting_setup_sync ()

## Properties

GStrv | calls | Read / Write
gboolean | emergency-only | Read / Write

## Signals

void | call-added | Run Last
void | call-deleted | Run Last
gboolean | handle-call-waiting-query | Run Last
gboolean | handle-call-waiting-setup | Run Last
gboolean | handle-create-call | Run Last
gboolean | handle-delete-call | Run Last
gboolean | handle-hangup-all | Run Last
gboolean | handle-hangup-and-accept | Run Last
gboolean | handle-hold-and-accept | Run Last
gboolean | handle-list-calls | Run Last
gboolean | handle-transfer | Run Last

## Types and Values

| MmGdbusModemVoice
struct | MmGdbusModemVoiceIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusModemVoice

## Prerequisites

MmGdbusModemVoice requires GObject.

## Known Implementations

MmGdbusModemVoice is implemented by MMModemVoice, MmGdbusModemVoiceProxy and MmGdbusModemVoiceSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Modem.Voice D-Bus interface in C.

## Functions

### mm_gdbus_modem_voice_get_calls ()

    const gchar *const *
    mm_gdbus_modem_voice_get_calls (MmGdbusModemVoice *object);

Gets the value of the "Calls" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_voice_dup_calls()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemVoice. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_voice_dup_calls ()

    gchar **
    mm_gdbus_modem_voice_dup_calls (MmGdbusModemVoice *object);

Gets a copy of the "Calls" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemVoice. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_strfreev()`.

[transfer full][nullable]

### mm_gdbus_modem_voice_get_emergency_only ()

    gboolean
    mm_gdbus_modem_voice_get_emergency_only
                                   (MmGdbusModemVoice *object);

Gets the value of the "EmergencyOnly" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemVoice. |

#### Returns

The property value.

### mm_gdbus_modem_voice_call_create_call ()

    void
    mm_gdbus_modem_voice_call_create_call (MmGdbusModemVoice *proxy,
                                           GVariant *arg_properties,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

Asynchronously invokes the `CreateCall()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_create_call_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_create_call_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_properties | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_create_call_finish ()

    gboolean
    mm_gdbus_modem_voice_call_create_call_finish
                                   (MmGdbusModemVoice *proxy,
                                    gchar **out_path,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_create_call()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
out_path | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_create_call()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_create_call_sync ()

    gboolean
    mm_gdbus_modem_voice_call_create_call_sync
                                   (MmGdbusModemVoice *proxy,
                                    GVariant *arg_properties,
                                    gchar **out_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CreateCall()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_create_call()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_properties | Argument to pass with the method invocation. |
out_path | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_delete_call ()

    void
    mm_gdbus_modem_voice_call_delete_call (MmGdbusModemVoice *proxy,
                                           const gchar *arg_path,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

Asynchronously invokes the `DeleteCall()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_delete_call_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_delete_call_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_path | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_delete_call_finish ()

    gboolean
    mm_gdbus_modem_voice_call_delete_call_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_delete_call()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_delete_call()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_delete_call_sync ()

    gboolean
    mm_gdbus_modem_voice_call_delete_call_sync
                                   (MmGdbusModemVoice *proxy,
                                    const gchar *arg_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `DeleteCall()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_delete_call()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_path | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_list_calls ()

    void
    mm_gdbus_modem_voice_call_list_calls (MmGdbusModemVoice *proxy,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `ListCalls()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_list_calls_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_list_calls_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_list_calls_finish ()

    gboolean
    mm_gdbus_modem_voice_call_list_calls_finish
                                   (MmGdbusModemVoice *proxy,
                                    gchar ***out_result,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_list_calls()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
out_result | Return location for return parameter or `NULL` to ignore. | [out][optional][array zero-terminated=1]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_list_calls()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_list_calls_sync ()

    gboolean
    mm_gdbus_modem_voice_call_list_calls_sync
                                   (MmGdbusModemVoice *proxy,
                                    gchar ***out_result,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `ListCalls()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_list_calls()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
out_result | Return location for return parameter or `NULL` to ignore. | [out][optional][array zero-terminated=1]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hangup_and_accept ()

    void
    mm_gdbus_modem_voice_call_hangup_and_accept
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `HangupAndAccept()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_hangup_and_accept_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_hangup_and_accept_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_hangup_and_accept_finish ()

    gboolean
    mm_gdbus_modem_voice_call_hangup_and_accept_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_hangup_and_accept()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_hangup_and_accept()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hangup_and_accept_sync ()

    gboolean
    mm_gdbus_modem_voice_call_hangup_and_accept_sync
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `HangupAndAccept()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_hangup_and_accept()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hold_and_accept ()

    void
    mm_gdbus_modem_voice_call_hold_and_accept
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `HoldAndAccept()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_hold_and_accept_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_hold_and_accept_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_hold_and_accept_finish ()

    gboolean
    mm_gdbus_modem_voice_call_hold_and_accept_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_hold_and_accept()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_hold_and_accept()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hold_and_accept_sync ()

    gboolean
    mm_gdbus_modem_voice_call_hold_and_accept_sync
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `HoldAndAccept()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_hold_and_accept()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hangup_all ()

    void
    mm_gdbus_modem_voice_call_hangup_all (MmGdbusModemVoice *proxy,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `HangupAll()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_hangup_all_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_hangup_all_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_hangup_all_finish ()

    gboolean
    mm_gdbus_modem_voice_call_hangup_all_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_hangup_all()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_hangup_all()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_hangup_all_sync ()

    gboolean
    mm_gdbus_modem_voice_call_hangup_all_sync
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `HangupAll()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_hangup_all()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_transfer ()

    void
    mm_gdbus_modem_voice_call_transfer (MmGdbusModemVoice *proxy,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

Asynchronously invokes the `Transfer()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_transfer_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_transfer_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_transfer_finish ()

    gboolean
    mm_gdbus_modem_voice_call_transfer_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_transfer()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_transfer()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_transfer_sync ()

    gboolean
    mm_gdbus_modem_voice_call_transfer_sync
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Transfer()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_transfer()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_call_waiting_query ()

    void
    mm_gdbus_modem_voice_call_call_waiting_query
                                   (MmGdbusModemVoice *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CallWaitingQuery()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_call_waiting_query_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_call_waiting_query_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_call_waiting_query_finish ()

    gboolean
    mm_gdbus_modem_voice_call_call_waiting_query_finish
                                   (MmGdbusModemVoice *proxy,
                                    gboolean *out_status,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_call_waiting_query()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
out_status | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_call_waiting_query()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_call_waiting_query_sync ()

    gboolean
    mm_gdbus_modem_voice_call_call_waiting_query_sync
                                   (MmGdbusModemVoice *proxy,
                                    gboolean *out_status,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CallWaitingQuery()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_call_waiting_query()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
out_status | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_call_waiting_setup ()

    void
    mm_gdbus_modem_voice_call_call_waiting_setup
                                   (MmGdbusModemVoice *proxy,
                                    gboolean arg_enable,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CallWaitingSetup()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_voice_call_call_waiting_setup_finish()` to get the result of the operation.

See `mm_gdbus_modem_voice_call_call_waiting_setup_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_enable | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_voice_call_call_waiting_setup_finish ()

    gboolean
    mm_gdbus_modem_voice_call_call_waiting_setup_finish
                                   (MmGdbusModemVoice *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_voice_call_call_waiting_setup()`.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_voice_call_call_waiting_setup()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_voice_call_call_waiting_setup_sync ()

    gboolean
    mm_gdbus_modem_voice_call_call_waiting_setup_sync
                                   (MmGdbusModemVoice *proxy,
                                    gboolean arg_enable,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CallWaitingSetup()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_voice_call_call_waiting_setup()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemVoiceProxy. |
arg_enable | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusModemVoice

    typedef struct _MmGdbusModemVoice MmGdbusModemVoice;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Modem.Voice.

### struct MmGdbusModemVoiceIface

    struct MmGdbusModemVoiceIface {
      GTypeInterface parent_iface;

      gboolean (*handle_call_waiting_query) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_call_waiting_setup) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation,
        gboolean arg_enable);

      gboolean (*handle_create_call) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_properties);

      gboolean (*handle_delete_call) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_path);

      gboolean (*handle_hangup_all) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_hangup_and_accept) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_hold_and_accept) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_list_calls) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_transfer) (
        MmGdbusModemVoice *object,
        GDBusMethodInvocation *invocation);

      const gchar *const * (*get_calls) (MmGdbusModemVoice *object);

      gboolean  (*get_emergency_only) (MmGdbusModemVoice *object);

      void (*call_added) (
        MmGdbusModemVoice *object,
        const gchar *arg_path);

      void (*call_deleted) (
        MmGdbusModemVoice *object,
        const gchar *arg_path);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Modem.Voice.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_call_waiting_query` () | Handler for the “handle-call-waiting-query” signal. |
`handle_call_waiting_setup` () | Handler for the “handle-call-waiting-setup” signal. |
`handle_create_call` () | Handler for the “handle-create-call” signal. |
`handle_delete_call` () | Handler for the “handle-delete-call” signal. |
`handle_hangup_all` () | Handler for the “handle-hangup-all” signal. |
`handle_hangup_and_accept` () | Handler for the “handle-hangup-and-accept” signal. |
`handle_hold_and_accept` () | Handler for the “handle-hold-and-accept” signal. |
`handle_list_calls` () | Handler for the “handle-list-calls” signal. |
`handle_transfer` () | Handler for the “handle-transfer” signal. |
`get_calls` () | Getter for the “calls” property. |
`get_emergency_only` () | Getter for the “emergency-only” property. |
`call_added` () | Handler for the “call-added” signal. |
`call_deleted` () | Handler for the “call-deleted” signal. |

## Property Details

### The `“calls”` property

      “calls”                    GStrv

Represents the D-Bus property "Calls".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemVoice

Flags: Read / Write

### The `“emergency-only”` property

      “emergency-only”           gboolean

Represents the D-Bus property "EmergencyOnly".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemVoice

Flags: Read / Write

Default value: FALSE

## Signal Details

### The `“call-added”` signal

    void
    user_function (MmGdbusModemVoice *object,
                   char              *arg_path,
                   gpointer           user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "CallAdded" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A MmGdbusModemVoice. |
arg_path | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“call-deleted”` signal

    void
    user_function (MmGdbusModemVoice *object,
                   char              *arg_path,
                   gpointer           user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "CallDeleted" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A MmGdbusModemVoice. |
arg_path | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“handle-call-waiting-query”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CallWaitingQuery()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_call_waiting_query()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-call-waiting-setup”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gboolean               arg_enable,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CallWaitingSetup()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_call_waiting_setup()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
arg_enable | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-create-call”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_properties,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CreateCall()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_create_call()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
arg_properties | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-delete-call”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_path,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `DeleteCall()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_delete_call()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
arg_path | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-hangup-all”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `HangupAll()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_hangup_all()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-hangup-and-accept”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `HangupAndAccept()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_hangup_and_accept()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-hold-and-accept”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `HoldAndAccept()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_hold_and_accept()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-list-calls”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `ListCalls()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_list_calls()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-transfer”` signal

    gboolean
    user_function (MmGdbusModemVoice     *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Transfer()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_voice_complete_transfer()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemVoice. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last